﻿// ActionScript 3.0クラス定義ファイル: EllipticMotion.as
// 回転するMovieClipシンボルの[クラス]に設定
package {
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.filters.BlurFilter;
	import flash.geom.Point;
	public class EllipticMotion extends MovieClip {
		private var degree:Number = 0;
		private var radian:Number = 0;
		private var speed:Number = 5;
		private var degreeToRadian:Number = Math.PI / 180;
		private var centerX:Number;// 初期値なし
		private var centerY:Number;// 初期値なし
		private var radiusX:Number;// 初期値なし
		private var radiusY:Number;// 初期値なし
		private var cos:Number = Math.cos(radian);
		private var sin:Number = Math.sin(radian);
		public function EllipticMotion(nDegree:Number, myCenter:Point, myRadius:Point) {
			degree = nDegree;
			centerX = myCenter.x;
			centerY = myCenter.y;
			radiusX = myRadius.x;
			radiusY = myRadius.y;
			addEventListener(Event.ENTER_FRAME, moveX);
			addEventListener(Event.ENTER_FRAME, moveY);
			addEventListener(Event.ENTER_FRAME, scale);
			addEventListener(Event.ENTER_FRAME, blur);
			addEventListener(Event.ENTER_FRAME, update);
		}
		private function moveX(eventObject:Event):void {
			x = centerX + cos * radiusX;
		}
		private function moveY(eventObject:Event):void {
			y = centerY + sin * radiusY;
		}
		private function scale(eventObject:Event):void {
			scaleX = scaleY = getIndexZ(0.8,1);
			scaleX *= getIndexZ();
		}
		private function blur(eventObject:Event):void {
			var nBlur:Number=getIndexZ(4,0);
			var myBlur:BlurFilter=new BlurFilter(nBlur,nBlur/2);
			filters=[myBlur];
		}
		private function update(eventObject:Event):void {
			degree+=speed;
			degree = (degree%360+360)%360;
			radian=degree*degreeToRadian;
			cos=Math.cos(radian);
			sin=Math.sin(radian);
		}
		private function getIndexZ(nMin:Number=-1, nMax:Number=1):Number {
			var nIndexZ:Number = (nMax-nMin)*(sin+1)/2+nMin;
			return nIndexZ;
		}
	}
}